"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var client_1 = require("./client");
exports.respondToGets = function (Gun, _a) {
    var _b = _a === void 0 ? {} : _a, _c = _b.disableRelay, disableRelay = _c === void 0 ? true : _c, _d = _b.skipValidation, skipValidation = _d === void 0 ? true : _d;
    return function (db) {
        var localforage = (Gun.localforage = db.localforage = new client_1.GunLocalForageClient(Gun));
        db.onIn(function gunLmdbRespondToGets(msg) {
            return __awaiter(this, void 0, void 0, function () {
                var _a, from, json, fromCluster, get, soul, dedupId, node, put, json_1, err_1, json_2;
                return __generator(this, function (_b) {
                    switch (_b.label) {
                        case 0:
                            from = msg.from, json = msg.json, fromCluster = msg.fromCluster;
                            get = json && json.get;
                            soul = get && get['#'];
                            dedupId = (json && json['#']) || '';
                            if (!soul || fromCluster)
                                return [2 /*return*/, msg];
                            _b.label = 1;
                        case 1:
                            _b.trys.push([1, 3, , 4]);
                            return [4 /*yield*/, localforage.get(soul)];
                        case 2:
                            node = (_b.sent()) || null;
                            put = 'null';
                            json_1 = {
                                '#': from.msgId(),
                                '@': dedupId,
                                put: node ? (_a = {}, _a[soul] = node, _a) : null
                            };
                            from.send({
                                json: json_1,
                                ignoreLeeching: true,
                                skipValidation: !node || skipValidation
                            });
                            return [2 /*return*/, disableRelay && node ? __assign({}, msg, { noRelay: true }) : msg];
                        case 3:
                            err_1 = _b.sent();
                            console.error('get err', err_1.stack || err_1);
                            json_2 = {
                                '#': from.msgId(),
                                '@': dedupId,
                                err: "" + err_1
                            };
                            from.send({ json: json_2, ignoreLeeching: true, skipValidation: skipValidation });
                            return [2 /*return*/, msg];
                        case 4: return [2 /*return*/];
                    }
                });
            });
        });
        return db;
    };
};
exports.acceptWrites = function (Gun, _a) {
    var _b = (_a === void 0 ? {} : _a).disableRelay, disableRelay = _b === void 0 ? false : _b;
    return function (db) {
        var localforage = (Gun.localforage = db.localforage = new client_1.GunLocalForageClient(Gun));
        db.onIn(function gunLmdbAcceptWrites(msg) {
            return __awaiter(this, void 0, void 0, function () {
                var diff, souls, json, err_2, json;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (msg.fromCluster || !msg.json.put)
                                return [2 /*return*/, msg];
                            return [4 /*yield*/, db.getDiff(msg.json.put)];
                        case 1:
                            diff = _a.sent();
                            souls = diff && Object.keys(diff);
                            if (!souls || !souls.length) {
                                return [2 /*return*/, disableRelay ? __assign({}, msg, { noRelay: true }) : msg];
                            }
                            _a.label = 2;
                        case 2:
                            _a.trys.push([2, 4, , 5]);
                            return [4 /*yield*/, localforage.write(diff)];
                        case 3:
                            _a.sent();
                            json = { '@': msg.json['#'], ok: true, err: null };
                            msg.from &&
                                msg.from.send &&
                                msg.from.send({
                                    json: json,
                                    noRelay: true,
                                    ignoreLeeching: true,
                                    skipValidation: true
                                });
                            return [2 /*return*/, msg];
                        case 4:
                            err_2 = _a.sent();
                            console.error('error writing data', err_2);
                            json = { '@': msg.json['#'], ok: false, err: "" + err_2 };
                            msg.from &&
                                msg.from.send &&
                                msg.from.send({
                                    json: json,
                                    noRelay: disableRelay,
                                    ignoreLeeching: true,
                                    skipValidation: true
                                });
                            return [2 /*return*/, msg];
                        case 5: return [2 /*return*/];
                    }
                });
            });
        });
        return db;
    };
};
//# sourceMappingURL=receiver.js.map